<script setup lang="ts">import { ref, onMounted, watch, onUnmounted } from 'vue';
import { ThreeContext } from '../../code/ThreeContext';

const emit = defineEmits<{
    (event: "newNodeSelectedEvent", path: string[]) : void,
	(event: "newSelectableChildrenEvent", children: string[]) : void
}>();
const props = defineProps({
    treePath: {
        type: Array,
        default() {
            return ["test1", "test2", "test3"]
        }
    }
})

const threeCtxElement = ref<HTMLElement>()
let threeContext = ref<ThreeContext>();

watch(()=>props.treePath as any, (newPath: string[], oldPath: string[]) => {
    // check if is equal. If difference -> emit new Path
    let isEqual = newPath.length === oldPath.length;

    for(let i = 0; i < newPath.length; i++) {
        if(!isEqual) {
            break;
        }
        if(newPath[i] !== oldPath[i]) {
            isEqual = false;
        }
    }

    if(!isEqual && !!threeContext.value) {
        // Spread is done to remove Vue's Array-Wrapper
        threeContext.value.notifyAboutNewTreeLocation([...newPath]);
    }
})




// Subscribe to the Context changing its current context
onMounted( () => {
    const threeCtx = new ThreeContext(threeCtxElement.value!);
    threeCtx.treeLocationChangedEvent.addListener( (data) => emit("newNodeSelectedEvent", data))
	threeCtx.newSelectableChildrenEvent.addListener( (children) => emit("newSelectableChildrenEvent", children))
    threeContext.value = threeCtx;
	threeCtx.notifyAboutNewTreeLocation(props.treePath as string[])
})

onUnmounted( () => {
    if(!!threeContext.value) {
        threeContext.value.dispose();
        threeContext.value = undefined;
    }
})
</script>


<template>
<div ref="threeCtxElement" id="threeCtx"/>
</template>

<style scoped lang="scss">
div#threeCtx {
    width: 100%;
    height: 100%;
    position: fixed;
    top: 0;
    left: 0;
    background-color: red;
    z-index: -1;

    // This is used when there is a valid target on hover
    &.show-pointer {
        cursor: pointer;
    }
}


</style>
